<?php

/*
Plugin Name: Eye-Able Wordpress Plugin
Plugin URI: https://eye-able.com/en
Description: With Eye-Able you make your website visible. The display of the content can be configured individually according to the visual needs of the users.
Version: 2.17
Author: Tobias Greiner - Web Inclusion GmbH
License: Copyright (C) Web Inclusion GmbH - All Rights Reserved
Text Domain: wordpress-eye-able-assistant
Domain Path: /languages/
*/

//prevent public user to directly access your .php files through URL. Anti-attacker
defined('ABSPATH') or die("Thanks for visting");


// funtion for updating
require 'plugin-update-checker-4.13/plugin-update-checker.php';
$myUpdateChecker = Puc_v4_Factory::buildUpdateChecker(
	'https://cdn.eye-able.com/plugins/wordpress/wordpress-eye-able-assistant/plugin-update-checker-4.13/examples/plugin.json',
	__FILE__, //Full path to the main plugin file or functions.php.
	'wordpress-eye-able-assistant'
);


// translation // more Information : https://developer.wordpress.org/plugins/internationalization/localization/   ; https://codex.wordpress.org/I18n_for_WordPress_Developers   ; https://make.wordpress.org/polyglots/teams/
function myplugin_init() {
    $plugin_rel_path = basename( dirname( __FILE__ ) ) . '/languages/'; /* Relative to WP_PLUGIN_DIR */
    load_plugin_textdomain( 'wordpress-eye-able-assistant', false, $plugin_rel_path );
}
add_action('plugins_loaded', 'myplugin_init');


//localize and activate js
function eyeAble_enqueue_scripts()
{

    //$version = "1.9.182";

    wp_enqueue_script('eyeAblePlugin', plugins_url('public/js/eyeAble.js', __FILE__),array(), null);
	//wp_enqueue_script('eyeAblePlugin', plugins_url('public/js/eyeAble.js', __FILE__));

    //wp_enqueue_script('test', plugins_url('license_sync.js', __FILE__),array(), $version);
	$option_array = get_option( 'eye_able_plugin_einstellungen_option_name');
	if ($option_array["license"] == "auto detect"){
		$configarray = checkConfig($GLOBALS["website"]);
		$Params = selfsetPara($configarray, $GLOBALS["website"]);
		$key_license = $Params["license"];
		$option_array["license"] = $key_license;
		update_option( 'eye_able_plugin_einstellungen_option_name', $option_array );
	}	
    wp_localize_script('eyeAblePlugin', 'eyeAble_pluginConfig', $option_array ); //localhost
}

add_action('wp_enqueue_scripts', 'eyeAble_enqueue_scripts');


// fügt banner im Admin-Bereich ein, wenn keine Vollversion/Config Datei vorliegt

function wpb_admin_notice_warn() {
	$configarray = checkConfig($GLOBALS["website"]);
	if (is_array($configarray)==false)
	{
			echo '<div class="notice notice-info is-dismissible">
			<p> ' . esc_html__("Eye Able: Buy the full version now. For more Information visit us under",'wordpress-eye-able-assistant'). '<a href=' . esc_html__('https://eye-able.com/en/ target="_blank"', "wordpress-eye-able-assistant"). '> Eye Able</a>' . ' </p>
			</div>'; 
				
	}

	}
	function error_message() {
		echo '<div class="notice notice-info is-dismissible">
		<p> ' . esc_html__("Something went wrong. Please contact us under",'wordpress-eye-able-assistant'). '<a href=' . esc_html__('https://eye-able.com/en/ target="_blank"', "wordpress-eye-able-assistant"). '> Eye Able</a>' . ' </p>
		</div>'; 
			


}


add_action( 'admin_notices', 'wpb_admin_notice_warn' );

	


$website = $_SERVER['HTTP_HOST'];

$option = get_option( 'eye_able_plugin_einstellungen_option_name');

if (is_array($option)){
	if (array_key_exists("eye_able_lizenz_0", $option)){
		$old_options = $option;
		delete_option('eye_able_plugin_einstellungen_option_name');
		$configarray = checkConfig($GLOBALS["website"]);
		$Params = selfsetPara($configarray, $GLOBALS["website"]);
		$key_license = $Params["license"];
		if (is_array($configarray)){
			$option_array = array_merge($configarray, $Params);
		}
		else{
			$option_array = $Params;
		}
		$option_array["allowLocalhost"] = "true";
		$option_array["pluginPath"] = plugins_url('', __FILE__);
		$option_array["license"] = $old_options['eye_able_lizenz_0'];
		if ($option_array["license"] == "auto detect"){
			$option_array["license"] = $key_license;
		}		
		$option_array["topPosition"] = $old_options['top_position_1'];
		$option_array["customIconColor"] = $old_options['customIconColor_2'];
		$option_array["customBackgroundColor"] = $old_options['customBackgroundColor_3'];
		$option_array["mobileBottomPosition"] = $old_options['mobileBottomPosition_4'];
		$option_array["blacklistContrast"] = $old_options['blacklistContrast_5'];
		$option_array["blacklistDarkmode"] = $old_options['blacklistDarkmode_6'];
		$option_array["blacklistFontsize"] = $old_options['blacklistFontsize_7'];
		$option_array["forceWhiteBackground"] = $old_options['forceWhiteBackground_8'];
		$option_array["maxMagnification"] = $old_options['maxMagnification_9'];
		$option_array["fontsizeThreshold"] = $old_options['fontsizeThreshold_10'];
		$option_array["iconSize"] = $old_options['iconSize_11'];
		$option_array["sidePosition"] = $old_options['sidePosition_12'];
		add_option('eye_able_plugin_einstellungen_option_name', $option_array);
	}
}




//delete_option( 'eye_able_plugin_einstellungen_option_name' );

function checkConfig_noAPI($website){
	$URL = "https://cdn.eye-able.com/configs/".$website.".js";
	$ch = curl_init($URL);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $config_content = curl_exec($ch);
	$httpCode_ch = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);
	if ($httpCode_ch == 200) { 
		$config_content = explode("eyeAble_pluginConfig =",$config_content)[1];
		$config_content_array = json_decode($config_content, true);								
}
else {
	switch ($website){ // extend or reduce website by www. 
		case str_contains($website, "www."):
			$website_ext = str_replace("www.", "", $website); 
			break; 
		case strpos($website ,"www.")===false: 
			$website_ext = "www." . $website;
			break;
		}	
		$URL = "https://cdn.eye-able.com/configs/".$website_ext.".js";
		$ch = curl_init($URL);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		$config_content = curl_exec($ch);
		$httpCode_ch = curl_getinfo($ch, CURLINFO_HTTP_CODE);
		curl_close($ch);
		if ($httpCode_ch == 200) { 
						
			$config_content = explode("eyeAble_pluginConfig =",$config_content)[1];
			$config_content_array = json_decode($config_content, true);								
	}
		else{
			$config_content_array = "keine config Datei gefunden";
		}
}
	return $config_content_array;

}



// function checks, if a config dat exists, if yes it returns the values in array if no a str
	function checkConfig($website){
		$request_config_url = 'https://api.eye-able.com/websiteConfig?domain='.$website;
		$curl_checkconfig = curl_init($request_config_url);
		curl_setopt($curl_checkconfig, CURLOPT_RETURNTRANSFER, true);
		$response_checkconfig = curl_exec($curl_checkconfig);
		$httpCode_checkconfig = curl_getinfo($curl_checkconfig, CURLINFO_HTTP_CODE);
		curl_close($curl_checkconfig);
		if ($httpCode_checkconfig == 200) { 
					
					$config_data = json_decode($response_checkconfig, true);
											
			}
		else {
			switch ($website){ // extend or reduce website by www. 
				case str_contains($website, "www."):
					$website_ext = str_replace("www.", "", $website); 
					break; 
				case strpos($website ,"www.")===false: 
					$website_ext = "www." . $website;
					break;
					}	
				$request_url = 'https://api.eye-able.com/websiteConfig?domain='. $website_ext;
				$curl_checkconfig = curl_init($request_url);
				curl_setopt($curl_checkconfig, CURLOPT_RETURNTRANSFER, true);
				$response_checkconfig = curl_exec($curl_checkconfig);
				$httpCode_checkconfig = curl_getinfo($curl_checkconfig, CURLINFO_HTTP_CODE);
				curl_close($curl_checkconfig);
				if ($httpCode_checkconfig == 200) { 
						$config_data = json_decode($response_checkconfig, true);		

					}
				else{
					
					$config_data = checkConfig_noAPI($website);
				}

 		}
		return $config_data;
	}



// function get values that can be selfset from config array. If not there are  set = ""
	function getConfigValues($array_values){

			if (array_key_exists("topPosition", $array_values)){
				$top_position_value = $array_values["topPosition"]; 
			}
			else {
				$top_position_value="";
			}
			if (array_key_exists("customIconColor", $array_values)){
				$customIconColor_value = $array_values["customIconColor"];
			}
			else {
				$customIconColor_value="";
			}
			if (array_key_exists("customBackgroundColor", $array_values)){
				$customBackgroundColor_value = $array_values["customBackgroundColor"];
			}
			else {
				$customBackgroundColor_value="";
			}
			if (array_key_exists("mobileBottomPosition", $array_values)){
				$mobileBottomPosition_value = $array_values["mobileBottomPosition"];
			}
			else {
				$mobileBottomPosition_value="";
			}
			if (array_key_exists("license", $array_values)){
				$license_value = $array_values["license"];  
			}
			else {
				$license_value="";
			}
			if (array_key_exists("blacklistContrast", $array_values)){
				$blacklistContrast_value = $array_values["blacklistContrast"]; 
			}
			else {
				$blacklistContrast_value="";
			}
			if (array_key_exists("blacklistDarkmode", $array_values)){
				$blacklistDarkmode_value = $array_values["blacklistDarkmode"]; 
			}
			else {
				$blacklistDarkmode_value="";
			}
			if (array_key_exists("blacklistFontsize", $array_values)){
				$blacklistFontsize_value = $array_values["blacklistFontsize"]; 
			}
			else {
				$blacklistFontsize_value="";
			}
			if (array_key_exists("forceWhiteBackground", $array_values)){
				$forceWhiteBackground_value = $array_values["forceWhiteBackground"]; 
			}
			else {
				$forceWhiteBackground_value="";
			}
			if (array_key_exists("maxMagnification", $array_values)){
				$maxMagnification_value = $array_values["maxMagnification"]; 
			}
			else {
				$maxMagnification_value="";
			}
			if (array_key_exists("fontsizeThreshold", $array_values)){
				$fontsizeThreshold_value = $array_values["fontsizeThreshold"]; 
			}
			else {
				$fontsizeThreshold_value="";
			}
			if (array_key_exists("iconSize", $array_values)){
				$iconSize_value = $array_values["iconSize"]; 
			}
			else {
				$iconSize_value="";
			}
			if (array_key_exists("sidePosition", $array_values)){
				$sidePosition_value = $array_values["sidePosition"]; 
			}
			else {
				$sidePosition_value="";
			}

			return array(
				"topPosition" => $top_position_value,
				"customIconColor" =>$customIconColor_value,
				"customBackgroundColor" =>$customBackgroundColor_value,
				"mobileBottomPosition" => $mobileBottomPosition_value,
				"license" => $license_value,
				"blacklistContrast" => $blacklistContrast_value,
				"blacklistDarkmode" => $blacklistDarkmode_value,
				"blacklistFontsize" => $blacklistFontsize_value,
				"forceWhiteBackground" => $forceWhiteBackground_value,
				"maxMagnification" => $maxMagnification_value,
				"fontsizeThreshold" => $fontsizeThreshold_value,
				"iconSize" => $iconSize_value,
				"sidePosition" => $sidePosition_value,

			);
		}




	/// check for license if there is no license put in a testlicence.
function getLicence ($website){

		$url = "https://api.eye-able.com/";
		$api_extension_checklicense = "websiteLicense"; 
		$request_url = $url . $api_extension_checklicense . "?domain=" . $website;
		$curl_checklicense = curl_init($request_url);
		curl_setopt($curl_checklicense, CURLOPT_RETURNTRANSFER, true);
		$response_checklicense = curl_exec($curl_checklicense);
		$httpCode_checklicense = curl_getinfo($curl_checklicense, CURLINFO_HTTP_CODE);
		curl_close($curl_checklicense);
		if ($httpCode_checklicense == 200) { 
				
				$licence_response = json_decode($response_checklicense);
				
				$key_license = $licence_response[0]->licenseKey;
					
		}
		else {
			switch ($website){ // extend or reduce website by www. 
				case str_contains($website, "www."):
					$website_ext = str_replace("www.", "", $website); 
					break; 
				case strpos($website ,"www.")===false: 
					$website_ext = "www." . $website;
					break;
				}	
				$request_url = $url . $api_extension_checklicense . "?domain=" . $website_ext;
				$curl_checklicense = curl_init($request_url);
				curl_setopt($curl_checklicense, CURLOPT_RETURNTRANSFER, true);
				$response_checklicense = curl_exec($curl_checklicense);
				$httpCode_checklicense = curl_getinfo($curl_checklicense, CURLINFO_HTTP_CODE);
				curl_close($curl_checklicense);
				if ($httpCode_checklicense == 200) { 
						$licence_response = json_decode($response_checklicense);
						$key_license = $licence_response[0]->licenseKey;	
			
				}

				else{
					$key_license = "12345";
					/*
					$api_extension_testlicense = "websiteTestLicense";
					$api_key = "t8q762c2f898NX64";
					$request_url_testlicense = $url . $api_extension_testlicense . "?apiKey=" . $api_key . "&domain=" . $website . "&createServerConfig=true";   
					$curl_testLicense = curl_init($request_url_testlicense);
					curl_setopt($curl_testLicense, CURLOPT_RETURNTRANSFER, true);
					$response_testlicense = curl_exec($curl_testLicense);
					$httpCode_testlicense = curl_getinfo($curl_testLicense, CURLINFO_HTTP_CODE);
					curl_close($curl_testLicense);
					if ($httpCode_testlicense == 200) { 
						$testlicense_response = json_decode($response_testlicense);
						$key_license = $testlicense_response->license->key;			
						
					} 
					else {
						$key_license = $httpCode_testlicense . "Something went wrong";					

						
					}*/
				}

	
					
		}	
		return $key_license;
	}
		
			
	function selfsetPara($configarray, $website){
		try{
			if (is_array($configarray)){
				$selfsetPara = getConfigValues($configarray, $website);
			}
			else {
				$selfsetPara = array("topPosition" => "",
									"customIconColor" =>"",
									"customBackgroundColor" =>"",
									"mobileBottomPosition" => "",
									"license" => "",
									"blacklistContrast" => "",
									"blacklistDarkmode" => "",
									"blacklistFontsize" => "",
									"forceWhiteBackground" => "",
									"maxMagnification" => "",
									"fontsizeThreshold" => "",
									"iconSize" => "",
									"sidePosition" => "",
									"mainIconAlt" =>2						
								);
				$selfsetPara["license"] = getLicence($website);
			}
	
		}
		catch(Error $e){
			$selfsetPara = array("topPosition" => "",
			"customIconColor" =>"",
			"customBackgroundColor" =>"",
			"mobileBottomPosition" => "",
			"license" => "12345",
			"blacklistContrast" => "",
			"blacklistDarkmode" => "",
			"blacklistFontsize" => "",
			"forceWhiteBackground" => "",
			"maxMagnification" => "",
			"fontsizeThreshold" => "",
			"iconSize" => "",
			"sidePosition" => "",
			"mainIconAlt" =>2						
		);
		add_action( 'admin_notices', 'error_message' );
	
		}
	
		return $selfsetPara;
	}
	

	
$logo_path = plugins_url("wordpress-eye-able-assistant/public/images/"); 
$logo = $logo_path."eye-able-logo2.png";

/**
 * Generated by the WordPress Option Page generator
 * at https://jeremyhixon.com/tool/wordpress-option-page-generator/
 */

class EyeAblePluginEinstellungen {
	
	private $eye_able_plugin_einstellungen_options;

	

	public function __construct() {
		add_action( 'admin_menu', array( $this, 'eye_able_plugin_einstellungen_add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'eye_able_plugin_einstellungen_page_init' ) );
	}

	public function eye_able_plugin_einstellungen_add_plugin_page() {
		
	if (get_option( 'eye_able_plugin_einstellungen_option_name')==false){
		$configarray = checkConfig($GLOBALS["website"]);
		$Params = selfsetPara($configarray, $GLOBALS["website"]);
		if (is_array($configarray)){
			$option_array = array_merge($configarray, $Params);
		}
		else{
			$option_array = $Params;
		}
		$option_array["allowLocalhost"] = "true";
		$option_array["pluginPath"] = plugins_url('', __FILE__);
		add_option('eye_able_plugin_einstellungen_option_name', $option_array);
	}
		add_plugins_page(
			__('Eye-Able Plugin Settings', "wordpress-eye-able-assistant"), // page_title
			__('Eye-Able Plugin Settings', "wordpress-eye-able-assistant"), // menu_title
			'manage_options', // capability
			'eye-able-plugin-einstellungen', // menu_slug
			array( $this, 'eye_able_plugin_einstellungen_create_admin_page' ) // function
		);
	}

	public function eye_able_plugin_einstellungen_create_admin_page() {
		
		$this->eye_able_plugin_einstellungen_options = get_option( 'eye_able_plugin_einstellungen_option_name' ) ; ?>		
		<head>
		</head>
		<style>
			body {
 				background-color: black;
  				
			}

			h2{
				color:#FFFFFF;
			}


			 label{
				color:white;
				margin-left: 7px;
			 }
			
			 .Intro  {
				background-color:#303439;
				color:#FFFFFF;
				padding: 0.5em;
				border-radius:10px;
				
			 }

			 .Explaination {
				color:#FFFFFF;
				border:1px; 
				border-style:solid; 
				border-color:#FFFFFF; 
				padding: 0.5em;
				border-radius:10px;
			 }
			 .Explaination:before {
				content: "✅";
				margin-right: 4px;
				}

			 #submit{
				color:black;
				background-color: #FFFFFF;
				
			 }
			 #reset {
				color:black;
				background-color: #FFFFFF;
			 }



			 img{
				width:10%;
				height:"auto";
				float:right;
				clear:right;
				margin: 0 2%
			 }

			 .helpcenter{
				color:#FFFFFF;
			 }


		</style>
		<body >
		<a href="https://eye-able.com/en/" target="_blank"><img  src="<?php echo $GLOBALS["logo"];?>" alt="Logo Eye Able" > </a>
			<div class="wrap"  >
				<b><h2 ><?php esc_html_e("Eye-Able® Plugin Settings",'wordpress-eye-able-assistant'); ?></h2></b>

				<div class = "Intro" >
				
					<p><b><?php esc_html_e("Change the settings for the Eye-Able plugin. The following settings are possible:",'wordpress-eye-able-assistant'); ?></b></p>
					<p class="Explaination"><b><?php esc_html_e("Eye-Able License:",'wordpress-eye-able-assistant'); ?></b> <?php esc_html_e("We detect your License or create a Testlicense automatically. In this case the value is set to 'auto detect'. When in need of changing the license: Enter the submitted license.",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Top Position:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("Set the position of the plugin on the page. Input as a number, which determines in % or px the distance from the top.",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Icon Colour:" ,'wordpress-eye-able-assistant'); ?> </b><?php esc_html_e("Set the colour of the icon on the page. Input as HTML color code or as color name (e.g. red)",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Background Colour:",'wordpress-eye-able-assistant'); ?></b>  <?php esc_html_e("Set the colour of the background of the icon on the page. Input as HTML color code or as color name (e.g. red)",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Mobile Position:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("Set the postion of the plugin for the mobile version.",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Blacklist Contrast:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("No contrast-mode changes for class, id or tagname: e.g. '.test',#1,nav' .Also stops images from being hidden,",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Blacklist Darkmode:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("No darkmode-mode changes for class, id or tagname: e.g. '.test',#1,nav'",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Blacklist Fontsize:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("No fontsize-mode changes for class, id or tagname: e.g. '.test',#1,nav'",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Force White Background:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("Places a white backgroudn behind the element",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Max Magnification:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("Maximum Magnification level",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Fontsize Threshold:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("Sets the maximum font size magnification",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Icon Size:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("Set the size of the Icon",'wordpress-eye-able-assistant'); ?></p>
					<p class="Explaination"><b><?php esc_html_e("Side Position:",'wordpress-eye-able-assistant'); ?>  </b><?php esc_html_e("Side of the Icon (left or right)",'wordpress-eye-able-assistant'); ?></p>

					<b><h4><?php esc_html_e("Attention! If you are facing issues regarding the plugin: press 'Reset' and then 'Save Setttings'. This resets the plugin to initial settings. If there are still problems contact us under info@eye-able.com ",'wordpress-eye-able-assistant'); ?></h4></b>

				</div>
				<br> 
				<h2><?php esc_html_e("Settings",'wordpress-eye-able-assistant'); ?></h2>
				<?php settings_errors(); ?>
				<form method="post" action="options.php" >
			 			<div style="background-color:#303439; border-radius:10px">
							<?php settings_fields( 'eye_able_plugin_einstellungen_option_group' )?>;
							<?php do_settings_sections( 'eye-able-plugin-einstellungen-admin' )?>;
						</div>
						<div id="wrapperDiv">
							<div id="safe" style="padding:20px;float:left"><b><?php submit_button(__("Save Settings", "wordpress-eye-able-assistant"))?> </b></div>
							<div id="reset_div" style="padding:20px;float:left"><b><?php submit_button(__('Reset', "wordpress-eye-able-assistant"), 'secondary', 'reset')?></b></div>
							<div class="helpcenter"> <b><?php esc_html_e("Need help? Contact us under info@eye-able.com",'wordpress-eye-able-assistant'); ?> </b></div>
						</div>
				</form>


			</div>
		</body>
	<?php }

	public function eye_able_plugin_einstellungen_page_init() {

		register_setting(
			'eye_able_plugin_einstellungen_option_group', // option_group
			'eye_able_plugin_einstellungen_option_name', // option_name
			array( $this, 'eye_able_plugin_einstellungen_sanitize' ) // sanitize_callback
		);

		add_settings_section(
			'eye_able_plugin_einstellungen_setting_section', // id
			'', // title
			array( $this, 'eye_able_plugin_einstellungen_section_info' ), // callback
			'eye-able-plugin-einstellungen-admin' // page
			
			
		);

		add_settings_field(
			'license', // id
			__('Eye-Able License', "wordpress-eye-able-assistant"), // title
			array( $this, 'license_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'license') // creates a label tag around the setting title - necessary to colour it
		);

		add_settings_field(
			'topPosition', // id
			'Top-Position', // title
			array( $this, 'topPosition_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'topPosition') // creates a label tag around the setting title - necessary to colour it
		);

		add_settings_field(
			'customIconColor', // id
			__('Icon Colour', "wordpress-eye-able-assistant"), // title
			array( $this, 'customIconColor_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'customIconColor') // creates a label tag around the setting title - necessary to colour it
		);

		add_settings_field(
			'customBackgroundColor', // id
			__('Background Colour',"wordpress-eye-able-assistant"), // title
			array( $this, 'customBackgroundColor_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'customBackgroundColor') // creates a label tag around the setting title - necessary to colour it
		);
		
		add_settings_field(
			'mobileBottomPosition', // id
			'Mobile Position', // title
			array( $this, 'mobileBottomPosition_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'mobileBottomPosition') // creates a label tag around the setting title - necessary to colour it
		);
		add_settings_field(
			'blacklistContrast', // id
			__('Blacklist Contrast', "wordpress-eye-able-assistant"), // title
			array( $this, 'blacklistContrast_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'blacklistContrast') // creates a label tag around the setting title - necessary to colour it
		);
		add_settings_field(
			'blacklistDarkmode', // id
			__('Blacklist Darkmode', "wordpress-eye-able-assistant"), // title
			array( $this, 'blacklistDarkmode_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'blacklistDarkmode') // creates a label tag around the setting title - necessary to colour it
		);
		add_settings_field(
			'blacklistFontsize', // id
			__('Blacklist Fontsize', "wordpress-eye-able-assistant"), // title
			array( $this, 'blacklistFontsize_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'blacklistFontsize') // creates a label tag around the setting title - necessary to colour it
		);
		add_settings_field(
			'forceWhiteBackground', // id
			__('Force White Background', "wordpress-eye-able-assistant"), // title
			array( $this, 'forceWhiteBackground_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'forceWhiteBackground') // creates a label tag around the setting title - necessary to colour it
		);
		add_settings_field(
			'maxMagnification', // id
			__('Max Magnification', "wordpress-eye-able-assistant"), // title
			array( $this, 'maxMagnification_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'maxMagnification') // creates a label tag around the setting title - necessary to colour it
		);
		add_settings_field(
			'fontsizeThreshold', // id
			__('Fontsize Threshold', "wordpress-eye-able-assistant"), // title
			array( $this, 'fontsizeThreshold_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'fontsizeThreshold') // creates a label tag around the setting title - necessary to colour it
		);
		add_settings_field(
			'iconSize', // id
			__('Icon SIze', "wordpress-eye-able-assistant"), // title
			array( $this, 'iconSize_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'iconSize') // creates a label tag around the setting title - necessary to colour it
		);
		add_settings_field(
			'sidePosition', // id
			__('Side Position', "wordpress-eye-able-assistant"), // title
			array( $this, 'sidePosition_callback' ), // callback
			'eye-able-plugin-einstellungen-admin', // page
			'eye_able_plugin_einstellungen_setting_section', // section
			array("label_for" =>'sidePosition') // creates a label tag around the setting title - necessary to colour it
		);
		

	}

	public function eye_able_plugin_einstellungen_sanitize($input) {

		//$sanitary_values = array();
		$configarray = checkConfig($GLOBALS["website"]);
		$Params = selfsetPara($configarray, $GLOBALS["website"]);
		$key_license = $Params["license"];
		if (is_array($configarray)){
			$option_array = array_merge($configarray, $Params);
		}
		else{
			$option_array = $Params;
		}
		$option_array["allowLocalhost"] = "true";
		$option_array["pluginPath"] = plugins_url('', __FILE__);
		


		if (isset($_POST['reset'])) {
			$sanitary_values = $option_array;
			add_settings_error('settingName', 'SettingSlug', __('Your settings has been changed default setting.', 'wordpress-eye-able-assistant'), 'updated');
	
		}
		else{	
			$sanitary_values = $option_array;
			
			if ( isset( $input['license'] ) ) {
				if (sanitize_text_field( $input['license'])=="auto detect"){
					$sanitary_values['license'] = $key_license;
				}
				else{
					$sanitary_values['license'] = sanitize_text_field( $input['license'] );
						if (str_starts_with($sanitary_values['license'], "{") and str_ends_with($sanitary_values['license'], "}")){
							$sanitary_values['license'] = json_decode($sanitary_values['license'], true);
							
						}		
						
					}

				}
				
			
	
			if ( isset( $input['topPosition'] ) ) {
				$sanitary_values['topPosition'] = sanitize_text_field( $input['topPosition'] );
			}
	
			if ( isset( $input['customIconColor'] ) ) {
				$sanitary_values['customIconColor'] = esc_textarea( $input['customIconColor'] );
			}
	
			if ( isset( $input['customBackgroundColor'] ) ) {
				$sanitary_values['customBackgroundColor'] = esc_textarea( $input['customBackgroundColor'] );
			}
			
			if ( isset( $input['mobileBottomPosition'] ) ) {
				$sanitary_values['mobileBottomPosition'] = esc_textarea( $input['mobileBottomPosition'] );
			}
			if ( isset( $input['blacklistContrast'] ) ) {
				$sanitary_values['blacklistContrast'] = esc_textarea( $input['blacklistContrast'] );
			}
			if ( isset( $input['blacklistDarkmode'] ) ) {
				$sanitary_values['blacklistDarkmode'] = esc_textarea( $input['blacklistDarkmode'] );
			}
			if ( isset( $input['blacklistFontsize'] ) ) {
				$sanitary_values['blacklistFontsize'] = esc_textarea( $input['blacklistFontsize'] );
			}
			if ( isset( $input['forceWhiteBackground'] ) ) {
				$sanitary_values['forceWhiteBackground'] = esc_textarea( $input['forceWhiteBackground'] );
			}
			if ( isset( $input['maxMagnification'] ) ) {
				$sanitary_values['maxMagnification'] = esc_textarea( $input['maxMagnification'] );
			}
			if ( isset( $input['fontsizeThreshold'] ) ) {
				$sanitary_values['fontsizeThreshold'] = esc_textarea( $input['fontsizeThreshold'] );
			}
			if ( isset( $input['iconSize'] ) ) {
				$sanitary_values['iconSize'] = esc_textarea( $input['iconSize'] );
			}
			if ( isset( $input['sidePosition'] ) ) {
				$sanitary_values['sidePosition'] = esc_textarea( $input['sidePosition'] );
			}
			
		}

		return $sanitary_values;
	}
	
	
	public function eye_able_plugin_einstellungen_section_info() {

	}

	public function license_callback() {
		$configarray = checkConfig($GLOBALS["website"]);
		$Params = selfsetPara($configarray, $GLOBALS["website"]);
		$key_license = $Params["license"];
		/// FÜR DAS UPDATE - TESTEN BEZÜGLICH license hier in den options. Wie sieht das bei einer "vollen Lizenze aus?". Also wenn das keine Testlizenz ist.
		if ($key_license != $this->eye_able_plugin_einstellungen_options['license']){
			if (is_array($this -> eye_able_plugin_einstellungen_options['license'])){
				$License = json_encode($this -> eye_able_plugin_einstellungen_options['license']);

			}
			else {
				$License = $this -> eye_able_plugin_einstellungen_options['license'];
			}
			
		
			printf(
				'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[license]" id="license" value="%s">',
				isset( $License ) ? esc_attr( $License) : "auto detect"
			);}
		elseif ($key_license == "Something went wrong"){
			printf(
				'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[license]" id="license" value="License not detected - please contact us under eye-able.com">',
				
			);
		}
		else {
			printf(
				'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[license]" id="license" value="auto detect">',
				
			);
		}
	}
	
	public function your_field_callback($args){
		
	}

	public function topPosition_callback() {

		//$array_selfset = $GLOBALS["selfsetPara"];
		//$this->eye_able_plugin_einstellungen_options['topPosition'] = $array_selfset["topPosition"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[topPosition]" id="topPosition" value="%s">',
			isset( $this->eye_able_plugin_einstellungen_options['topPosition'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['topPosition']) : ""//$array_selfset["topPosition"]
		);
	}

	public function customIconColor_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[customIconColor]" id="customIconColor" value="%s" >', 
			isset( $this->eye_able_plugin_einstellungen_options['customIconColor'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['customIconColor']) : ""//$array_selfset["customIconColor"]
		);
	}

	public function customBackgroundColor_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[customBackgroundColor]" id="customBackgroundColor" value="%s">',
			isset( $this->eye_able_plugin_einstellungen_options['customBackgroundColor'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['customBackgroundColor']) : ""//$array_selfset["customBackgroundColor"]
		);
	}
	
	public function mobileBottomPosition_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[mobileBottomPosition]" id="mobileBottomPosition" value = "%s">',
			isset( $this->eye_able_plugin_einstellungen_options['mobileBottomPosition'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['mobileBottomPosition']) : ""//$array_selfset["mobileBottomPosition"]
		);
	}
	public function blacklistContrast_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[blacklistContrast]" id="blacklistContrast" value = "%s">',
			isset( $this->eye_able_plugin_einstellungen_options['blacklistContrast'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['blacklistContrast']) : ""//$array_selfset["blacklistContrast"]
		);
	}
	public function blacklistDarkmode_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[blacklistDarkmode]" id="blacklistDarkmode" value = "%s">',
			isset( $this->eye_able_plugin_einstellungen_options['blacklistDarkmode'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['blacklistDarkmode']) : ""//$array_selfset["blacklistDarkmode"]
		);
	}
	public function blacklistFontsize_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[blacklistFontsize]" id="blacklistFontsize" value = "%s">',
			isset( $this->eye_able_plugin_einstellungen_options['blacklistFontsize'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['blacklistFontsize']) : ""//$array_selfset["blacklistFontsize"]
		);
	}
	public function forceWhiteBackground_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[forceWhiteBackground]" id="forceWhiteBackground" value = "%s">',
			isset( $this->eye_able_plugin_einstellungen_options['forceWhiteBackground'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['forceWhiteBackground']) : ""//$array_selfset["forceWhiteBackground"]
		);
	}
	public function maxMagnification_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[maxMagnification]" id="maxMagnification" value = "%s">',
			isset( $this->eye_able_plugin_einstellungen_options['maxMagnification'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['maxMagnification']) : ""//$array_selfset["maxMagnification"]
		);
	}
	public function fontsizeThreshold_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[fontsizeThreshold]" id="fontsizeThreshold" value = "%s">',
			isset( $this->eye_able_plugin_einstellungen_options['fontsizeThreshold'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['fontsizeThreshold']) : ""//$array_selfset["fontsizeThreshold"]
		);
	}
	public function iconSize_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[iconSize]" id="iconSize" value = "%s">',
			isset( $this->eye_able_plugin_einstellungen_options['iconSize'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['iconSize']) : ""//$array_selfset["iconSize"]
		);
	}
	public function sidePosition_callback() {
		//$array_selfset = $GLOBALS["selfsetPara"];
		printf(
			'<input class="regular-text" type="text" name="eye_able_plugin_einstellungen_option_name[sidePosition]" id="sidePosition" value = "%s">',
			isset( $this->eye_able_plugin_einstellungen_options['sidePosition'] ) ? esc_attr( $this->eye_able_plugin_einstellungen_options['sidePosition']) : ""//$array_selfset["sidePosition"]
		);
	}

}
if ( is_admin() )
	$eye_able_plugin_einstellungen = new EyeAblePluginEinstellungen();

/*
 * Retrieve this value with:
 * $eye_able_plugin_einstellungen_options = get_option( 'eye_able_plugin_einstellungen_option_name' ); // Array of All Options
 * $license = $eye_able_plugin_einstellungen_options['license']; // Eye-Able Lizenz
 * $topPosition = $eye_able_plugin_einstellungen_options['topPosition']; // Top-Position
 * $blacklist_alles_blockieren_2 = $eye_able_plugin_einstellungen_options['blacklist_alles_blockieren_2']; // Blacklist: Alles blockieren
 * $blacklist_nachtmodus_blockieren_3 = $eye_able_plugin_einstellungen_options['blacklist_nachtmodus_blockieren_3']; // Blacklist: Nachtmodus blockieren
 * $blacklist_schriftgrsse_blockieren_4 = $eye_able_plugin_einstellungen_options['blacklist_schriftgrsse_blockieren_4']; // Blacklist: Schriftgröße blockieren
 * $schriftvergrsserung_schwellwert_5 = $eye_able_plugin_einstellungen_options['schriftvergrsserung_schwellwert_5']; // Schriftvergrößerung-Schwellwert
 * $maximale_vergrsserung_6 = $eye_able_plugin_einstellungen_options['maximale_vergrsserung_6']; // Maximale Vergrößerung
 */


?>